//#-hidden-code
//
//  See LICENSE folder for this template’s licensing information.
//
//  Abstract:
//  The Swift file containing the source code edited by the user of this playground book.
//
import PlaygroundSupport
let page = PlaygroundPage.current
page.needsIndefiniteExecution = true
func send(_ str: String) {
    if let proxy1 = page.liveView as? PlaygroundRemoteLiveViewProxy {
        let message: PlaygroundValue = .string(str)
        proxy1.send(message)
    }
}

func vprint(_ str: String) {
    send(str)
}
func vprint(_ int: Int) {
    send(String(int))
}
func vprint(_ double: Double) {
    send(String(double))
}
func vprint(_ float: Float) {
    send(String(float))
}
func vprint(_ bool: Bool) {
    send(String(bool))
}

func vprintln(_ str: String) {
   send(str+"\n")
}
func vprintln(_ int: Int) {
    send(String(int)+"\n")
}
func vprintln(_ double: Double) {
    send(String(double)+"\n")
}
func vprintln(_ float: Float) {
   send(String(float)+"\n")
}
func vprintln(_ bool: Bool) {
   send(String(bool)+"\n")
}
//#-end-hidden-code
/*: some text
 ## コンピュータが扱う数値について
　コンピュータの内部で扱われるのは**０**と**１**で表現できる数値の情報です。
 その数値の種類には、**整数**、**小数（浮動小数）**、**文字**、**論理値**などがあります。
 それぞれの値の特徴をしっかり捉えて、プログラミングを進めましょう。
 このような数値情報の種類のことを**データ型**と呼びます。

 * Note:
 Swiftの主なデータ型には、次のようなものがあります。\
 Int:整数型(Integer)、Float:浮動小数点型(Float)、Double:倍精度浮動小数点型(Double)、 String:文字列型(String)、Bool:論理型(Boolean)
---
 * Important:
 このBookで使用しているvprintln()、vprint()は、数値をこのBookの結果表示エリアに出力するためのもので、Swiftの文法にはありません。\
 vprintln():改行付きで結果出力、vprint():改行なしで結果出力
*/
//#-code-completion(everything, hide)
//#-editable-code
//各データ型の値を結果エリアに表示する
vprintln("こんにちは！") //文字型
vprintln(12)  //整数型
vprintln(1.012) //浮動小数点型
vprintln(true)//論理型
//#-end-editable-code
//#-hidden-code
import PlaygroundSupport
if( PlaygroundPage.current.assessmentStatus == nil ){
    PlaygroundPage.current.assessmentStatus = .pass(message: "実行できました!")
}
//#-end-hidden-code
