//#-hidden-code
//
//  See LICENSE folder for this template’s licensing information.
//
//  Abstract:
//  The Swift file containing the source code edited by the user of this playground book.
//
import PlaygroundSupport
let page = PlaygroundPage.current
page.needsIndefiniteExecution = true
func send(_ str: String) {
    if let proxy1 = page.liveView as? PlaygroundRemoteLiveViewProxy {
        let message: PlaygroundValue = .string(str)
        proxy1.send(message)
    }
}

func vprint(_ str: String) {
    send(str)
}
func vprint(_ int: Int) {
    send(String(int))
}
func vprint(_ double: Double) {
    send(String(double))
}
func vprint(_ float: Float) {
    send(String(float))
}
func vprint(_ bool: Bool) {
    send(String(bool))
}

func vprintln(_ str: String) {
   send(str+"\n")
}
func vprintln(_ int: Int) {
    send(String(int)+"\n")
}
func vprintln(_ double: Double) {
    send(String(double)+"\n")
}
func vprintln(_ float: Float) {
   send(String(float)+"\n")
}
func vprintln(_ bool: Bool) {
   send(String(bool)+"\n")
}
//#-end-hidden-code
/*: some text
 ## 変数について確認しましょう
　プログラムコードでは、数値を保管する場所を**変数**と言っています。**変数**を取り扱うためには、**データ型**を区別する必要があります。**変数**への数値の**代入**や**計算式**、文字列の結合をするための**計算式**を記述する際には、**データ型**を一致させる必要がある事を覚えておいてください。\
　**変数**に初期値を設定(**初期化**)したり、**変数**の**データ型**を指定する記述を、**宣言文**と呼んでいます。
 * Important:
 プログラムコード内で値を再び代入しない変数を初期化するためには、**let**を、値を変更する変数を使うためには、**var**を使用してください。
 */
//#-code-completion(everything, hide)
//#-editable-code
//変数の初期化と簡単な計算式
let a = "abcde"
let b = 10
var c = 2.15
let d = a + String(b)
c = Double(b) + c
vprintln(c)
vprintln(d)
//#-end-editable-code
//#-hidden-code
import PlaygroundSupport
if( PlaygroundPage.current.assessmentStatus == nil ){
    PlaygroundPage.current.assessmentStatus = .pass(message: "実行できました!")
}
//#-end-hidden-code
