//#-hidden-code
//
//  See LICENSE folder for this template’s licensing information.
//
//  Abstract:
//  The Swift file containing the source code edited by the user of this playground book.
//
import PlaygroundSupport
let page = PlaygroundPage.current
page.needsIndefiniteExecution = true
func send(_ str: String) {
    if let proxy1 = page.liveView as? PlaygroundRemoteLiveViewProxy {
        let message: PlaygroundValue = .string(str)
        proxy1.send(message)
    }
}

func vprint(_ str: String) {
    send(str)
}
func vprint(_ int: Int) {
    send(String(int))
}
func vprint(_ double: Double) {
    send(String(double))
}
func vprint(_ float: Float) {
    send(String(float))
}
func vprint(_ bool: Bool) {
    send(String(bool))
}

func vprintln(_ str: String) {
   send(str+"\n")
}
func vprintln(_ int: Int) {
    send(String(int)+"\n")
}
func vprintln(_ double: Double) {
    send(String(double)+"\n")
}
func vprintln(_ float: Float) {
   send(String(float)+"\n")
}
func vprintln(_ bool: Bool) {
   send(String(bool)+"\n")
}
//#-end-hidden-code
/*: some text
 ## コンピュータの計算には誤差がつきものです
　コンピュータは常に正しく計算しているのではなく、小数点以下の数値を計算する時には、**誤差**が入っている事が普通です。このような誤差は小さいので殆どの場合で大きな問題にはならないのですが、**誤差**がある事を知った上でプログラミングすることが大切です。
 */
//#-code-completion(everything, hide)
//#-editable-code
//計算誤差を確認するための浮動小数点数の計算
let a = Double(1.13)
let b = Double(1.15)
let c = a - b
vprintln(c)
//#-end-editable-code
//#-hidden-code
import PlaygroundSupport
if( PlaygroundPage.current.assessmentStatus == nil ){
    PlaygroundPage.current.assessmentStatus = .pass(message: "実行できました!")
}
//#-end-hidden-code

