//#-hidden-code
//
//  See LICENSE folder for this template’s licensing information.
//
//  Abstract:
//  The Swift file containing the source code edited by the user of this playground book.
//
import PlaygroundSupport
let page = PlaygroundPage.current
page.needsIndefiniteExecution = true
func send(_ str: String) {
    if let proxy1 = page.liveView as? PlaygroundRemoteLiveViewProxy {
        let message: PlaygroundValue = .string(str)
        proxy1.send(message)
    }
}

func vprint(_ str: String) {
    send(str)
}
func vprint(_ int: Int) {
    send(String(int))
}
func vprint(_ double: Double) {
    send(String(double))
}
func vprint(_ float: Float) {
    send(String(float))
}
func vprint(_ bool: Bool) {
    send(String(bool))
}

func vprintln(_ str: String) {
   send(str+"\n")
}
func vprintln(_ int: Int) {
    send(String(int)+"\n")
}
func vprintln(_ double: Double) {
    send(String(double)+"\n")
}
func vprintln(_ float: Float) {
   send(String(float)+"\n")
}
func vprintln(_ bool: Bool) {
   send(String(bool)+"\n")
}
//#-end-hidden-code
/*: some text
 ## 処理を繰り返す
　**ループ処理**を使うと、指定された回繰り返したり、ある条件が満たされるまで処理を繰り返すことができます。繰り返しの回数をカウントする変数の取り扱いには覚えておいて欲しい事があります。それは例えば１０回繰り返す時には０〜９までカウントするという事です。後で登場する**配列変数**が０番から始まるからで、疑問に思う人はそこで謎が解けます。
 * Important:
 Swiftのループ処理には、 **for** 、 **while** 、 **repeat-while** があります。処理の状況によって使い分ける事ができます。また、 **break**でループを抜けたり、 **continue**でループを強制継続できます。
 */
//#-code-completion(everything, hide)
//#-editable-code
//繰り返し(ループ）処理
for i in 0..<10 { //forループ
    vprintln("i = " + String(i))
}

var j = 0
while ( j < 10) { //whileループ
    vprintln("j = " + String(j))
    j += 1
}

var k = 0
repeat { //repeat-whileループ
    vprintln("k = " + String(k))
    k += 1
} while (k < 10)
//#-end-editable-code
//#-hidden-code
import PlaygroundSupport
if( PlaygroundPage.current.assessmentStatus == nil ){
    PlaygroundPage.current.assessmentStatus = .pass(message: "実行できました!")
}
//#-end-hidden-code
