//#-hidden-code
//
//  See LICENSE folder for this template’s licensing information.
//
//  Abstract:
//  The Swift file containing the source code edited by the user of this playground book.
//
import PlaygroundSupport
let page = PlaygroundPage.current
page.needsIndefiniteExecution = true
func send(_ str: String) {
    if let proxy1 = page.liveView as? PlaygroundRemoteLiveViewProxy {
        let message: PlaygroundValue = .string(str)
        proxy1.send(message)
    }
}

func vprint(_ str: String) {
    send(str)
}
func vprint(_ int: Int) {
    send(String(int))
}
func vprint(_ double: Double) {
    send(String(double))
}
func vprint(_ float: Float) {
    send(String(float))
}
func vprint(_ bool: Bool) {
    send(String(bool))
}

func vprintln(_ str: String) {
   send(str+"\n")
}
func vprintln(_ int: Int) {
    send(String(int)+"\n")
}
func vprintln(_ double: Double) {
    send(String(double)+"\n")
}
func vprintln(_ float: Float) {
   send(String(float)+"\n")
}
func vprintln(_ bool: Bool) {
   send(String(bool)+"\n")
}
//#-end-hidden-code
/*: some text
 ## 配列変数について
　データを連続的に格納するために使用するのが**配列変数**です。配列を使うことによって、繰り返し計算の計算結果の格納や、連続的なデータの受け渡しが簡単に記述できます。配列には、１次元配列、次元配列、３次元配列などのように配列を配列することもできます。
 
 * Note:
　Swiftでは、 **append()** を用いると、 **配列** の **要素**を追加することもできます。\
　**配列変数**の要素の数は、**配列名.count**で求める事ができるので、**forループ**の条件によく用いられます。
 */
//#-code-completion(everything, hide)
//#-editable-code
var youbi = [ "月曜", "火曜", "水曜", "木曜", "金曜", "土曜"]
youbi.append("日曜")
for i in 0..<youbi.count {
    vprint(youbi[i] + " ")
}
vprintln("")
for moji in youbi { //上と同じ処理
    vprint(moji + " ")
}
//#-end-editable-code
//#-hidden-code
import PlaygroundSupport
if( PlaygroundPage.current.assessmentStatus == nil ){
    PlaygroundPage.current.assessmentStatus = .pass(message: "実行できました!")
}
//#-end-hidden-code
