//#-hidden-code
//
//  See LICENSE folder for this template’s licensing information.
//
//  Abstract:
//  The Swift file containing the source code edited by the user of this playground book.
//
import PlaygroundSupport
let page = PlaygroundPage.current
page.needsIndefiniteExecution = true
func send(_ str: String) {
    if let proxy1 = page.liveView as? PlaygroundRemoteLiveViewProxy {
        let message: PlaygroundValue = .string(str)
        proxy1.send(message)
    }
}

func vprint(_ str: String) {
    send(str)
}
func vprint(_ int: Int) {
    send(String(int))
}
func vprint(_ double: Double) {
    send(String(double))
}
func vprint(_ float: Float) {
    send(String(float))
}
func vprint(_ bool: Bool) {
    send(String(bool))
}

func vprintln(_ str: String) {
   send(str+"\n")
}
func vprintln(_ int: Int) {
    send(String(int)+"\n")
}
func vprintln(_ double: Double) {
    send(String(double)+"\n")
}
func vprintln(_ float: Float) {
   send(String(float)+"\n")
}
func vprintln(_ bool: Bool) {
   send(String(bool)+"\n")
}
//#-end-hidden-code
/*: some text
 ## 関数の定義
　今まで使っていたString()のように括弧がついたキーワードは**関数**の呼び出しです。プログラムは数多くの**関数**によって構成されていて、自分で定義する事ができます。\
 **関数** に渡する値を **引数** と言い、関数からの結果を **戻り値** と言います。 **関数**を定義する際には、 **引数** や **戻り値** の **データ型** を明確に記述する必要があります。
 * Note:
 Swiftの関数定義は、\
 **func 関数名(引数名:引数のデータ型) -> 戻り値のデータ型 { ...プログラムコード... }** \
 のように記述します。関数名の括弧の次にアンダーバー( **_** ) をつけると、その関数を呼び出す際に**引数名**の指定を省略できるようになります。
 */
//#-code-completion(everything, hide)
//#-editable-code
//関数定義
func countadd(_ number: Int) -> Int {
    var count = 0
    for i in 0..<number {
        count += (i + 1)
    }
    return count
}
//メインプログラム
var n = 10
vprint("1から" + String(n) + "まで足し合わせた結果は:")
vprint(countadd(n))
//#-end-editable-code
//#-hidden-code
import PlaygroundSupport
if( PlaygroundPage.current.assessmentStatus == nil ){
    PlaygroundPage.current.assessmentStatus = .pass(message: "実行できました!")
}
//#-end-hidden-code
