//#-hidden-code
//
//  See LICENSE folder for this template’s licensing information.
//
//  Abstract:
//  The Swift file containing the source code edited by the user of this playground book.
//
import PlaygroundSupport
let page = PlaygroundPage.current
page.needsIndefiniteExecution = true
func send(_ str: String) {
    if let proxy1 = page.liveView as? PlaygroundRemoteLiveViewProxy {
        let message: PlaygroundValue = .string(str)
        proxy1.send(message)
    }
}

func vprint(_ str: String) {
    send(str)
}
func vprint(_ int: Int) {
    send(String(int))
}
func vprint(_ double: Double) {
    send(String(double))
}
func vprint(_ float: Float) {
    send(String(float))
}
func vprint(_ bool: Bool) {
    send(String(bool))
}

func vprintln(_ str: String) {
    send(str+"\n")
}
func vprintln(_ int: Int) {
    send(String(int)+"\n")
}
func vprintln(_ double: Double) {
    send(String(double)+"\n")
}
func vprintln(_ float: Float) {
    send(String(float)+"\n")
}
func vprintln(_ bool: Bool) {
    send(String(bool)+"\n")
}
//#-end-hidden-code
/*: some text
 ## アルゴリズムについて
　**アルゴリズム** とは、問題（計算など）を解くための手続き方法（ **算法** ）を指す言葉です。手続きを記述するプログラミングコードでは、**アルゴリズム** をうまく活用して様々な問題解決が図られています。\
   ここでは、配列の中からデータを探し出すための２つの**探索アルゴリズム（線形探索、二分探索）** を **関数** で記述してあります。データの値を変更しながら、その結果を確認してみてください。また、それぞれの関数内で比較回数をカウントしています。
 
 * Note:
 **線形探索(linear search)**\
  配列の先頭から順に値を比較して一致する場所を探し出すアルゴリズム。\
 **二分探索(binary search)**\
  昇順(もしくは降順)に並び替えられている配列内のデータの中央位置の値と比較し、大小関係から、半分ずつ探索範囲を狭めるアルゴリズム。
 */
//#-code-completion(everything, hide)
//#-editable-code
//線形探索関数
var lkaisuu = 0
func lsearch (_ data:[Int], _ value:Int) -> Int {
    for i in 0..<data.count {
        lkaisuu += 1 //比較回数
        if (data[i] == value) {
            return (i)
        }
    }
    return -1 //見つからなかった
}
//二分探索の関数
var bkaisuu = 0
func bsearch (_ data:[Int], _ value:Int, _ min:Int, _ max:Int) -> Int {
    bkaisuu += 1 //比較回数
    if (min > max) {
        return -1 //見つからなかった
    } else {
        let mid = min + Int((max - min) / 2)
        if (data[mid] > value) {
            return(bsearch(data, value, min, mid-1))
        } else if (data[mid] == value) {
            return(mid)
        } else {
            return(bsearch(data, value, mid+1, max))
        }
    }
}

//メインプログラム
let data = [2, 9, 15, 21, 28, 30, 37, 40, 51, 78]
let value = 21 //探す値
vprintln("データ配列の内容:")
for i in data {
    vprint(String(i) + " ")
}
vprintln("")
vprintln("")
vprintln("探したい値:" + String(value))
vprintln("")
var n = lsearch(data, value)
if n > 0 {
    vprintln("線形探索で見つかった場所:" + String(n + 1) + "番目")
} else {
    vprintln("線形探索では見つかりませんでした")
}
vprintln("線形探索の比較回数:" + String(lkaisuu))
vprintln("")
n = bsearch(data, value, 0, data.count)
if n > 0 {
    vprintln("二分探索で見つかった場所:" + String(n + 1) + "番目")
} else {
    vprintln("二分探索では見つかりませんでした")
}
vprintln("二分探索の比較回数:" + String(bkaisuu))
//#-end-editable-code
//#-hidden-code
import PlaygroundSupport
if( PlaygroundPage.current.assessmentStatus == nil ){
    PlaygroundPage.current.assessmentStatus = .pass(message: "実行できました!")
}
//#-end-hidden-code
