//#-hidden-code
//
//  See LICENSE folder for this template’s licensing information.
//
//  Abstract:
//  The Swift file containing the source code edited by the user of this playground book.
//
import BookCore
import UIKit
import PlaygroundSupport

//iPadが縦置きか横置きかで比率を変更する。
let myScreenWidth = UIScreen.main.bounds.size.width
let myScreenHeight = UIScreen.main.bounds.size.height
if (myScreenWidth > myScreenHeight) { //横置き
    let sc = ScatterPlot(xyData:(0.0,0.0),(0.0, 1.5)) //Y座標の倍率調整用
    sc.symbol = nil //見えないようにする
} else { //縦置き
    let sc = ScatterPlot(xyData:(0.0,0.0),(1.45, 0.0)) //X座標の倍率調整用
    sc.symbol = nil //見えないようにする
}

_setup()
//#-end-hidden-code
/*: some text
 ## モンテカルロ法で円周率を出してみよう
　原点を中心とした半径１の円の第一象限では４分の１の扇型となります。
 一様な乱数をX方向は０〜１まで、Y方向も０〜１までの範囲で発生させて、扇型の中に入った数を使えば円周率πが求まります。
 */
//#-code-completion(everything, hide)
//#-editable-code
//モンテカルロ法による円周率計算
let totalcount = 1000 //計算回数
var incount = 0 //円の内側に入った数
var  x  = 0.0 //X座標保存用
var y = 0.0 //Y座標保存用
var indata = XYData() //円に入ったデータのグラフ描画用配列
var outdata = XYData() //円から外れたデータのグラフ描画用配列
for i in 1 ... totalcount {
    x = Double.random(in: 0..<1.0)
    y = Double.random(in: 0..<1.0)
    if x*x+y*y<1.0 {
        indata.append(x: x, y: y)
        incount+=1
    } else {
        outdata.append(x: x, y: y)
    }
}
let scatterIn = ScatterPlot(xyData: indata) //入ったデータでグラフ描画
scatterIn.color = #colorLiteral(red: 0.9254902005195618, green: 0.23529411852359772, blue: 0.10196078568696976, alpha: 1.0)
let scatterOut = ScatterPlot(xyData: outdata) //外れたデータでグラフ描画
scatterOut.color = #colorLiteral(red: 0.21960784494876862, green: 0.007843137718737125, blue: 0.8549019694328308, alpha: 1.0)
scatterIn.label = "円周率:"+String (Double(incount )/Double(totalcount)*4.0)
//#-end-editable-code
//#-hidden-code
import PlaygroundSupport
if( PlaygroundPage.current.assessmentStatus == nil ){
    PlaygroundPage.current.assessmentStatus = .pass(message: "実行できました!")
}
//#-end-hidden-code
