//#-hidden-code
//
//  See LICENSE folder for this template’s licensing information.
//
//  Abstract:
//  The Swift file containing the source code edited by the user of this playground book.
//
import BookCore
_setup()
//#-end-hidden-code
/*: some text
 ## 放物運動を考えよう
　ここでは、物体が影響を受ける風や空気抵抗による摩擦を考えずに計算してみましょう。
 計算が上手くいったら、角度を調整してみてください。どんな角度だと一番遠くに飛ぶのか見つけてみてください。
 * Important:
  プログラムコードでは、角度をラジアン(弧度法)で記述します。１ラジアンはπ/180です。
 */
//#-code-completion(everything, hide)
//#-editable-code
//放物運動のシミュレーションプログラム
import UIKit //πの値を使うためにインポート
let dt=0.01 //微小時間
let v0=30.0 //初速度
let g=9.8 //重力加速度
let data = XYData() //グラフ表示用配列
var x = 0.0 //原点
var y = 0.0 //原点
var vx = [0.0] //速度の配列
var vy = [0.0] //速度ほ配列
let angle = 30.0*Double.pi/180.0 //角度をラジアンで設定
vx=[v0*cos(angle)] //X方向の初速度
vy=[v0*sin(angle)] //Y方向の初速度
for i in 0..<1000 {
    vx.append(vx[i])
    vy.append(vy[i]-g*dt)
    x = x+vx[i]*dt
    y = y+(vy[i]+vy[i+1])/2.0*dt
    if y < 0.0 {break} //Y座標が0を下回ったらループを抜ける
    data.append(x: x , y: y)
}
let lineplot = LinePlot(xyData: data) //グラフを描画
lineplot.label = "放物運動"
//#-end-editable-code
//#-hidden-code
import PlaygroundSupport
if( PlaygroundPage.current.assessmentStatus == nil ){
    PlaygroundPage.current.assessmentStatus = .pass(message: "実行できました!")
}
//#-end-hidden-code
