//
//  See LICENSE folder for this template’s licensing information.
//
//  Abstract:
//   playground ライブビューとコード間のメッセージハンドリング

import UIKit
import PlaygroundSupport

public class TextViewController: UIViewController,PlaygroundLiveViewSafeAreaContainer  {
    private var myTextView  = UITextView()
    private var vstring = String()

    public required init(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)!
    }
    
    public override init(nibName nibNameOrNil: String?, bundle nibBundleOrNil: Bundle?) {
        super.init(nibName: nibNameOrNil, bundle: nibBundleOrNil)
    }
    
    override public func viewDidLoad() {
        super.viewDidLoad()
        view.backgroundColor = #colorLiteral(red: 0.1019607857, green: 0.2784313858, blue: 0.400000006, alpha: 1)
        // disable auto layout
        view.translatesAutoresizingMaskIntoConstraints = false

        // ビューパーツをコンテナ基準で配置
       //テキストビューを配置
        myTextView.font = UIFont.systemFont(ofSize: 20)
        myTextView.isEditable = false
        view.addSubview(myTextView)
        //myTextView.textColor = #colorLiteral(red: 0, green: 0, blue: 0, alpha: 1)
        //myTextView.backgroundColor  = #colorLiteral(red: 1, green: 1, blue: 1, alpha: 0.2)
        myTextView.layer.cornerRadius = 10
        myTextView.layer.borderWidth = 1
        myTextView.layer.borderColor = UIColor.placeholderText.cgColor
        myTextView.translatesAutoresizingMaskIntoConstraints  = false
        myTextView.topAnchor.constraint(equalTo: liveViewSafeAreaGuide.topAnchor, constant: 40).isActive = true
         myTextView.bottomAnchor.constraint(equalTo: liveViewSafeAreaGuide.bottomAnchor, constant: -40).isActive = true
        myTextView.leadingAnchor.constraint(equalTo: liveViewSafeAreaGuide.leadingAnchor, constant: 20).isActive = true
        myTextView.trailingAnchor.constraint(equalTo: liveViewSafeAreaGuide.trailingAnchor, constant: -20).isActive = true
    }
    
    override public func viewWillAppear(_ animated: Bool) {
    }
    
}

extension TextViewController: PlaygroundLiveViewMessageHandler {
    //Playgroundページからメッセージを受け取る際の処理。
    public func receive(_ message: PlaygroundValue) {
        if case let .string(text) = message {
            myTextView.insertText(text)
        }
    }
   //Playgroundページにメッセージを送る際のサンプル。
    //public func tapped() {
    //    let message: PlaygroundValue = .string("Hello!")
        //myTextView.insertText("[send to your code]Hello!\n")
    //    send(message)
   // }
    
}


